/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
#include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
#include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>        /* For true/false definition */

#include "gpio.h"
#include "lcd.h"

/******************************************************************************/
/* User Functions                                                             */

/******************************************************************************/


void gpioSetTris(uint8_t pin, uint8_t direction) {
	switch (pin) {
	case 1:
		TRIS_GPIO1 = direction;
		break;
	case 2:
		TRIS_GPIO2 = direction;
		break;
	case 3:
		TRIS_GPIO3 = direction;
		break;
	case 4:
		TRIS_GPIO4 = direction;
		break;
	case 5:
		TRIS_GPIO5 = direction;
		break;
	case 6:
		TRIS_GPIO6 = direction;
		break;
	case 7:
		TRIS_GPIO7 = direction;
		break;
	case 8:
		TRIS_GPIO8 = direction;
		break;
	case 9:
		TRIS_GPIO9 = direction;
		break;
	default:
		break;
	}

}

void gpioSetLat(uint8_t pin, uint8_t level) {
	switch (pin) {
	case 1:
		PORT_GPIO1 = level;
		break;
	case 2:
		PORT_GPIO2 = level;
		break;
	case 3:
		if (TRIS_GPIO3)
			WPUBbits.WPUB7 = level;
		else
			PORT_GPIO3 = level;
		break;
	case 4:
		if (TRIS_GPIO4)
			WPUBbits.WPUB6 = level;
		else
			PORT_GPIO4 = level;
		break;
	case 5:
		if (TRIS_GPIO5)
			WPUBbits.WPUB5 = level;
		else
			PORT_GPIO5 = level;
		break;
	case 6:
		if (TRIS_GPIO6)
			WPUBbits.WPUB4 = level;
		else
			PORT_GPIO6 = level;
		break;
	case 7:
		PORT_GPIO7 = level;
		break;
	case 8:
		PORT_GPIO8 = level;
		break;
	case 9:
		PORT_GPIO9 = level;
		break;
	default:
		break;
	}
}

uint8_t gpioGetPort(uint8_t pin) {
	switch (pin) {
	case 1:
		return PORT_GPIO1;
	case 2:
		return PORT_GPIO2;
	case 3:
		return PORT_GPIO3;
	case 4:
		return PORT_GPIO4;
	case 5:
		return PORT_GPIO5;
	case 6:
		return PORT_GPIO6;
	case 7:
		return PORT_GPIO7;;
	case 8:
		return PORT_GPIO8;
	case 9:
		return PORT_GPIO9;
	default:
		return 0;
	}
	return 0;
}

uint8_t gpioGetButtons(void) {
	return PORTB & 0x0F;
}