/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include "usart.h"

/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/


void USART_Init(void) {
	TXSTAbits.SYNC = 0;		//Asynchronous mode
	TXSTAbits.BRGH = 1;		// High speed
	SPBRG = 103;			// 9600bps

	RCSTAbits.SPEN = 1;		//Serial port enabled and automatically configures the TX/CK I/O pin and Rx pin

	TXSTAbits.TXEN = 1;		//Transmit enabled
	RCSTAbits.CREN = 1;		//Enables continuous receive

	PIR1bits.RCIF = 0;
	PIE1bits.RCIE = 1;
}

void USART_Disable(void){

	PIR1bits.RCIF = 0;
	PIE1bits.RCIE = 0;

	TXSTAbits.TXEN = 0;
	RCSTAbits.CREN = 0;
	RCSTAbits.SPEN = 0;

	TRISCbits.TRISC6 = 1;		// RX
	TRISCbits.TRISC7 = 1;		// TX
}








